#ifndef _LIB_H
#define _LIB_H

#include "drup/types.h"

struct drup_state *drup_init (const struct drup_config *config);
bool drup_authenticate (const struct drup_state *state, uint8_t bus_number, uint8_t cfg, uint64_t device_id, const uint8_t * secret, bool *authenticated);
bool drup_generate_secret (const struct drup_state *state, uint8_t bus_number, uint8_t cfg, uint64_t device_id, uint8_t *secret);
bool drup_search (const struct drup_state *state, uint8_t device_family, uint64_t *device_id, char *device_id_str);
bool drup_search_init (const struct drup_state *state, uint8_t bus_number, uint8_t cfg, bool *presence);
uint8_t drup_cfg (bool overdrive, bool strong_pullup, bool active_pullup);
void drup_cleanup (struct drup_state *state);

#endif
