#ifndef _DS1961_H
#define _DS1961_H

#include <time.h>

#include "private/types.h"

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-variable"

static uint8_t CMD_LOAD_FIRST_SECRET = 0x5A;
static uint8_t CMD_READ_AUTH_PAGE    = 0xA5;
static uint8_t CMD_READ_SCRATCHPAD   = 0xAA;
static uint8_t CMD_WRITE_SCRATCHPAD  = 0x0F;
static uint8_t MEM_REGION_SECRET     = 0x80;

// --- the time it takes the device to calculate the MAC (1.5 ms)
static const struct timespec T_CSHA = { .tv_sec = 0, .tv_nsec =  1.5e6, };
// --- the time it takes the device to authenticate or load the secret (10 ms)
static const struct timespec T_PROG = { .tv_sec = 0, .tv_nsec = 10e6, };

bool ds1961_generate_secret (const struct key *key, uint8_t * secret);
bool ds1961_inv_crc16_validate (const uint8_t *data, uint8_t length);
bool ds1961_read_auth_page (const struct key *key, uint8_t *const rmac_read, uint8_t *rmac);
bool ds1961_write_scratchpad (const struct key *key, uint16_t addr, uint8_t *data);

#pragma GCC diagnostic pop

#endif
