#include <stddef.h>

#include <alleycat.h>

#include "private/bus.h"
#include "private/ds2482.h"
#include "private/i2c.h"
#include "private/types.h"
#include "private/util.h"

struct bus *bus_new (const struct master * const master, uint8_t const bus_num) {
  if (bus_num >= 8) ac_warn_rnull (
    "Invalid bus number %d", bus_num
  );
  try_malloc (struct bus, bus);
  if (bus == NULL) ac_pieprnull;
  bus->master = master;
  bus->number = bus_num;
  bus->chan_select = channels_select[bus_num];
  bus->chan_select_ack = channels_select_ack[bus_num];
  return bus;
}
